package com.ic.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import com.ic.constant.LeaderCalcConfig;
import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.FycMapping;
import com.ic.modules.auth.payload.fycDto;
import com.ic.modules.auth.repository.FycRepository;
import com.ic.modules.auth.service.FycMappingService;

@Service
public class FycMappingServiceImpl implements FycMappingService {

	@Autowired
	FycRepository fycRepo;
	
	LeaderCalcConfig LeaderCalcConfig;
	
	@Autowired
    public FycMappingServiceImpl(@Lazy LeaderCalcConfig LeaderCalcConfig) {
        this.LeaderCalcConfig = LeaderCalcConfig;
    }
	
	public FycMapping save(fycDto dto,Boolean isCreate) {
		
		if(!isCreate) {
			fycRepo.findById(dto.getId()).orElseThrow(()->new ResourceNotFoundException("fyc","key",dto.getId()));
		 }
		FycMapping fycMapping = null;
		 
	    fycMapping = new FycMapping();
	     fycMapping.setId(dto.getId());
		 fycMapping.setMaxval(dto.getMaxval());
		 fycMapping.setMinval(dto.getMival());
		 fycMapping.setPer(dto.getPer());
		 
		// DBConfig.setValue(dto.getKey(), dto.getMaxval(), dto.getMaxval(), dto.getMaxval());
		
		 
		 return fycRepo.save(fycMapping);
	
		 
	 }
	

	@Transactional(isolation=Isolation.READ_UNCOMMITTED)
	 public List<FycMapping> findAll(){    // neel gosrani 02-09-2020 Sql server migration
		 return fycRepo.findAll();
	 }
}
