package com.ic.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import com.ic.constant.LeaderCalcConfig;
import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.L1slabsMapping;
import com.ic.modules.auth.payload.L1slabsDto;
import com.ic.modules.auth.repository.L1slabsRepository;
import com.ic.modules.auth.service.L1slabsMappingService;




@Service
public class L1slabsMappingServiceImpl implements L1slabsMappingService {

	@Autowired
	L1slabsRepository l1slabsRepo;
	
	LeaderCalcConfig LeaderCalcConfig;
	
	@Autowired
    public L1slabsMappingServiceImpl(@Lazy LeaderCalcConfig LeaderCalcConfig) {
        this.LeaderCalcConfig = LeaderCalcConfig;
    }
	
	@Override
	@Transactional(isolation=Isolation.READ_UNCOMMITTED)
	public List<L1slabsMapping> findAll() {    // neel gosrani 02-09-2020 Sql server migration
		// TODO Auto-generated method stub
		 return l1slabsRepo.findAll();
	}
	
	public L1slabsMapping save(L1slabsDto dto,Boolean isCreate) {

		if(!isCreate) {
			l1slabsRepo.findById(dto.getId()).orElseThrow(()->new ResourceNotFoundException("l1slabs","key",dto.getId()));
		 }
		
		L1slabsMapping l1slabsmapping = null;

		l1slabsmapping = new L1slabsMapping();
		l1slabsmapping.setId(dto.getId());
		l1slabsmapping.setCBA(dto.getCBA());
		l1slabsmapping.setBA(dto.getBA());
		l1slabsmapping.setSBA(dto.getSBA());
		l1slabsmapping.setMaxval(dto.getMaxval());
		l1slabsmapping.setMinval(dto.getMinval());
		l1slabsmapping.setPartner(dto.getPartner());
		l1slabsmapping.setSenior_Partner(dto.getSenior_Partner());

		return l1slabsRepo.save(l1slabsmapping);

	}

}
