package com.ic.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import com.ic.constant.LeaderCalcConfig;
import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.MpbMapping;
import com.ic.modules.auth.payload.mpbDto;
import com.ic.modules.auth.repository.MpbRepository;
import com.ic.modules.auth.service.MpbMappingService;


@Service
public class MpbMappingServiceImpl implements MpbMappingService{

	@Autowired
	MpbRepository mpbrepository;
	
	LeaderCalcConfig LeaderCalcConfig;
	
	@Autowired
    public MpbMappingServiceImpl(@Lazy LeaderCalcConfig LeaderCalcConfig) {
        this.LeaderCalcConfig = LeaderCalcConfig;
    }
	
	@Override
	@Transactional(isolation=Isolation.READ_UNCOMMITTED)
	public List<MpbMapping> findAll() {    // neel gosrani 02-09-2020 Sql server migration
		 return mpbrepository.findAll();

	}
	
	public MpbMapping save(mpbDto dto,Boolean isCreate) {
		
		if(!isCreate) {
			mpbrepository.findById(dto.getId()).orElseThrow(()->new ResourceNotFoundException("mpb","key",dto.getId()));
		 }
		
		MpbMapping mpbMapping = null;
		 
		mpbMapping = new MpbMapping();
		//mpbMapping.setId(dto.getId());
		mpbMapping.setDT(dto.getDT());
		mpbMapping.setL1(dto.getL1());
		mpbMapping.setL2(dto.getL2());
		mpbMapping.setDesignation(dto.getDesignation());
        mpbMapping.setMapping_DT_minimum_fyc(dto.getMapping_DT_minimum_fyc());
		
		 
		 return mpbrepository.save(mpbMapping);
	
		 
	 }
	

}
