package com.ic.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import com.ic.constant.TemplateConfig;
import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.Templates;
import com.ic.modules.auth.payload.TemplatesDto;
import com.ic.modules.auth.repository.TemplatesRepository;
import com.ic.modules.auth.service.TemplatesService;

@Service
public class TemplatesServiceImpl implements TemplatesService {

	@Autowired
	TemplatesRepository configRepo;
	
	TemplateConfig templateConfig;
	
	@Autowired
    public TemplatesServiceImpl(@Lazy TemplateConfig templateConfig) {
        this.templateConfig = templateConfig;
    }
	
	public Templates save(TemplatesDto dto,Boolean isCreate) {
		 Templates configuration = null;
		 if(!isCreate) {
			 configRepo.findByProperty(dto.getKey()).orElseThrow(()->new ResourceNotFoundException("Template","key",dto.getKey()));
		 }else {
			 configuration = new Templates();
			 configuration.setProperty(dto.getKey());
		 }
		 configuration.setValue(dto.getValue());
		 configuration.setType(dto.getType());
		 templateConfig.setValue(dto.getKey(), dto.getValue());
		 return configRepo.save(configuration);
		 
	 }
	@Transactional(isolation=Isolation.READ_UNCOMMITTED)
	 public List<Templates> findAll(){
		 return configRepo.findAll();
	 }
	@Transactional(isolation=Isolation.READ_UNCOMMITTED)
	 public Templates findByKey(String key) {
		 return configRepo.findByProperty(key).orElseThrow(()->new ResourceNotFoundException("Template","key",key));
	 }
	 
}
